----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions principales autour desquelles s'articulent les autres fonctions --

----------------------------------------------------------------------------------------------------------------------------------------

--------------- ! Fonction principale ! ---------------
function jeu()
	-- ! On dcoupe la map du niveau en cours ! --
	decoupe_niveau()
	
	-- ! On selectionne les evenements du niveau ! --
	tri_events()
	
	-- ! On charge les variables du niveau ! --
	charger_var_niveau()
	
	-- On lance le compte  rebours 
	compte_a_rebours()
	
	-- ! Variable pour ne retenir qu'une seule pression de touche ! --
	oldpad = Controls.read()
	
	fin_du_jeu = false
	-- ! Boucle principale ! --
	
	IntraFont.init()
	while (fin_du_jeu == false) do
	
		-- ! Controle des touches ! -- 
		pad = Controls.read()
		
		
		if (pad:select()) then
			chrono:stop()
			afficher_aide(5)
			chrono:start()
			rafraichir = true
		end
		
		-- ! Si on doit actualiser l'cran ! --
		if (rafraichir == true) then
			screen:clear(Color.new(170,215,255))
			actualiser_ecran(1)
			screen.waitVblankStart()
			screen:flip()
		end
		
		
		-- ! Si une touche est presse ! --
		if (pad:right()) then
			touche:stop()
			touche:reset()
			touche:start()
			deplacer_tinwe("droite")
			verifier_action_possible()
			touche:stop()
			rafraichir = true
			
		elseif (pad:left()) then
			touche:stop()
			touche:reset()
			touche:start()
			deplacer_tinwe("gauche")
			verifier_action_possible()
			touche:stop()
			rafraichir = true
			
		elseif (pad:down()) then
			touche:stop()
			touche:reset()
			touche:start()
			deplacer_tinwe("bas")
			verifier_action_possible()
			touche:stop()
			rafraichir = true
			
		elseif (pad:up()) then
			touche:stop()
			touche:reset()
			touche:start()
			deplacer_tinwe("haut")
			verifier_action_possible()
			touche:stop()
			rafraichir = true
		-- ! On affichage un aperu global de la carte

		elseif (pad:triangle() and not oldpad:triangle()) then
			delai(200)
			chrono:stop()
			afficher_carte()
			chrono:start()
		elseif (pad:start() and not oldpad:start()) then
			delai(200)
			chrono:stop()
			menu_pause()
			chrono:start()
		end
		
		-- ! On mmorise que Tinw est pass sur cette case (pour l'affichage de la carte) ! --
		if (tab_passage[(all_maps[id_map].c*(ligne - 1) + colonne)] == false) then
			tab_passage[(all_maps[id_map].c*(ligne - 1) + colonne)] = true
		end
		
		
		-- ! Pour ne retenir qu'une seule pression de touche ! --
		oldpad = pad
		if (chrono:time() > 100) then
			if (tonumber(string.sub(chrono:time(),1,-3)) > (mem_temps + 20)) then
				chrono:reset(tonumber(mem_temps.."00"))
				chrono:start()
			end
		end
		if (chrono:time() < 100) or (tonumber(string.sub(chrono:time(),1,-3)) > mem_temps) then
			if (chrono:time() < 100) then
				mem_temps = 0
			else
				mem_temps = tonumber(string.sub(chrono:time(),1,-3))
			end
			rafraichir = true
		end
	end
	menu_principal()
	
	IntraFont.term()
end

--------------- ! Menu Principal ! ---------------
function menu_principal()
	background = Image.load("images/autres/background.png")
	rafraichir = true
	selecteur = 1
	choix = 0
	oldpad = Controls.read()
	while (choix == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			afficher_menu()
			screen.waitVblankStart()
			screen:flip()
		end
		
		action_touche_menu_principal()
		
		if (pad:select()) then
			afficher_aide(1)
			rafraichir = true
		end
		
		oldpad = pad
	end
	if (choix == 1) then
		background, rafraichir , selecteur, choix = nil
		type_partie = 1
		creer_maps(type_partie)
		creer_events(type_partie)
		menu_niveau()
		jeu()
	elseif (choix == 2) then
		background, rafraichir , selecteur, choix = nil
		type_partie = 2
		niveau_bloque = 1
		creer_maps(type_partie)
		creer_events(type_partie)
		menu_niveau()
		jeu()
	elseif (choix == 3) then
		background, rafraichir , selecteur, choix = nil
		menu_option()
	elseif (choix == 4) then
		background, rafraichir , selecteur, choix = nil
		System.runeboot("ms0:/PSP/GAME/cale_editor/EBOOT.PBP")
	end
end

--------------- ! Menu des options ! ---------------
function menu_option()
	background = Image.load("images/autres/background.png")
	rafraichir = true
	selecteur = 1
	choix = 0
	oldpad = Controls.read()
	while (choix == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			afficher_menu_option(1)
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:select()) then
			afficher_aide(2)
			rafraichir = true
		end
		if (pad:down() and not oldpad:down()) then
			if (selecteur == 3) then
				selecteur = 1
			else
				selecteur = selecteur + 1
			end
			rafraichir = true
		elseif (pad:up() and not oldpad:up()) then
			if (selecteur == 1) then
				selecteur = 3
			else
				selecteur = selecteur - 1
			end
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			choix = selecteur
		elseif (pad:circle() and not oldpad:circle()) then
			choix = -1
		end
		
		
		oldpad = pad
	end
	if (choix == -1) then
		background, rafraichir , selecteur, choix = nil
		menu_principal()
	elseif (choix == 1) then
		background, rafraichir , selecteur, choix = nil
		reinitialiser_arcade(1)
	elseif (choix == 2) then
		background, rafraichir , selecteur, choix = nil
		reinitialiser_arcade(2)
	elseif (choix == 3) then
		background, rafraichir , selecteur, choix = nil
		credits()
		menu_option()
	end
end

--------------- ! Lors d'une pause dans le jeu ! ---------------
function menu_pause()
	rafraichir = true
	choix_pause = 0
	oldpad = Controls.read()
	selecteur = 1
	while (choix_pause == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			screen:clear(Color.new(170,215,255))
			IntraFont.load("flash0:/font/ltn12.pgf", 1)
			actualiser_ecran(1)
			screen:blit(0,0,masque_pause)
			Gu.start3d()
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,190,"Continuer",1,0,0) - 240)/2)),170,"Continuer", 1, IntraFont.color(255,255,255,255), IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Recommencer",1,0,0) - 240)/2)),200,"Recommencer", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,220,"Quitter",1,0,0) - 240)/2)),230,"Quitter", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
			elseif (selecteur == 2) then
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,190,"Continuer",1,0,0) - 240)/2)),170,"Continuer", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,220,"Quitter",1,0,0) - 240)/2)),230,"Quitter", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Recommencer",1,0,0) - 240)/2)),200,"Recommencer", 1, IntraFont.color(255,255,255,255), IntraFont.color(100,100,100,255))
			elseif (selecteur == 3) then
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,190,"Continuer",1,0,0) - 240)/2)),170,"Continuer", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,220,"Recommencer",1,0,0) - 240)/2)),200,"Recommencer", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Quitter",1,0,0) - 240)/2)),230,"Quitter", 1, IntraFont.color(255,255,255,255), IntraFont.color(100,100,100,255))
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		
		if (pad:up() and not oldpad:up()) then
			if (selecteur == 1) then
				selecteur = 3
			else
				selecteur = selecteur - 1
			end
			rafraichir = true
		elseif (pad:down() and not oldpad:down()) then
			if (selecteur == 3) then
				selecteur = 1
			else
				selecteur = selecteur + 1
			end
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			choix_pause = selecteur
		end
		
		oldpad = pad
	end
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
	if (choix_pause == 2) then
		decoupe_niveau()
		-- ! On trie les evenements ! --
		tri_events()
		-- ! On charge les variables du niveau ! --
		charger_var_niveau()
		mem_temps = 0
		IntraFont.load("flash0:/font/ltn12.pgf", 1)
		compte_a_rebours()
	elseif (choix_pause == 3) then
		fin_du_jeu = true
		creer_maps(type_partie)
		creer_events(type_partie)
		menu_niveau()
		jeu()
	end
end

--------------- ! Lors du choix du niveau ! ---------------
function menu_niveau(var)
	img_choix_niveau = Image.load("images/autres/choix_niveau.png")
	img_sel_niv = Image.load("images/autres/niveau_selecteur.png")
	tab_medaille = {}
	tab_medaille[1] = Image.load("images/autres/ico_niveau.png")
	tab_medaille[2] = Image.load("images/autres/min_gold.png")
	tab_medaille[3] = Image.load("images/autres/min_silver.png")
	tab_medaille[4] = Image.load("images/autres/min_bronze.png")
	tab_medaille[5] = Image.load("images/autres/min_none.png")
	tab_medaille[6] = Image.load("images/autres/niveau_bloque.png")
	choix_niveau = 0
	if (niveau_bloque <= table.getn(all_maps)) then
		page = math.ceil(niveau_bloque/15)
	else
		page = 1
	end
	selection_niveau(page)
	nb_page = math.ceil(table.getn(all_maps)/15)
	init_x = (480-(nb_page*15))/2
	if (type_partie == 1) then
		ind_ligne = math.ceil((niveau_bloque - ((page - 1)*15))/5)
		ind_colonne = (niveau_bloque - ((page - 1)*15)) - (5*(ind_ligne-1))
		ind_niveau = (5*(ind_ligne-1))+ind_colonne
	else
		ind_ligne = 1
		ind_colonne = 1
		ind_niveau = 1
	end
	rafraichir = true
	oldpad = Controls.read()
	while (choix_niveau == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_niveau()
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:select() and not oldpad:select()) then
			if (type_partie == 1) then
				afficher_aide(3)
				rafraichir = true
			else
				afficher_aide(4)
				rafraichir = true
			end
		end
		if (pad:r() and not oldpad:r() and derniere_page == false) then
			page = page + 1
			ind_ligne = 1
			ind_colonne = 1
			ind_niveau = (ind_ligne-1)*5+ind_colonne
			selection_niveau(page)
			rafraichir = true
		elseif (pad:l() and not oldpad:l() and page > 1) then
			page = page - 1
			selection_niveau(page)
			rafraichir = true
		elseif (pad:right() and not oldpad:right()) then
			if (ind_colonne < 5) and ((page-1)*15+(ind_ligne-1)*5+ind_colonne < table.getn(all_maps))then
				ind_colonne = ind_colonne + 1
				rafraichir = true
				ind_niveau = (ind_ligne-1)*5+ind_colonne
			end
		elseif (pad:left() and not oldpad:left()) then
			if (ind_colonne ~= 1) then
				ind_colonne = ind_colonne - 1
				rafraichir = true
				ind_niveau = (ind_ligne-1)*5+ind_colonne
			end
		elseif (pad:down() and not oldpad:down()) then
			if (ind_ligne < 3) and ((page-1)*15+(ind_ligne)*5+ind_colonne <= table.getn(all_maps))then
				ind_ligne = ind_ligne + 1
				rafraichir = true
				ind_niveau = (ind_ligne-1)*5+ind_colonne
			end
		elseif (pad:up() and not oldpad:up()) then
			if (ind_ligne ~= 1) then
				ind_ligne = ind_ligne - 1
				rafraichir = true
				ind_niveau = (ind_ligne-1)*5+ind_colonne
			end
		elseif (pad:cross() and not oldpad:cross()) then
			if (type_partie == 1) then
				if (tab_sel[(ind_ligne-1)*5+ind_colonne].num <= niveau_bloque) then
					choix_niveau = tab_sel[(ind_ligne-1)*5+ind_colonne].num
				end
			else
				choix_niveau = tab_sel[(ind_ligne-1)*5+ind_colonne].num
			end
		elseif (pad:circle() and not oldpad:circle()) then
			choix_niveau = 0.5
		end
		oldpad = pad
	end
	img_choix_niveau, img_sel_niv, tab_medaille, nb_page, init_x, ind_niveau, ind_ligne, ind_colonne, rafraichir = nil
	id_map = choix_niveau
	if (choix_niveau == 0.5) then
		creer_maps(2)
		creer_events(2)
		menu_principal()
	end


end
------
