----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions secondaires --

----------------------------------------------------------------------------------------------------------------------------------------



--------------- ! Fonction qui permet de palier la sensibilit des touches ! ---------------
function delai(temps)
	timer = Timer.new()
	while (timer:time() < temps) do
		timer:start()
	end
	timer:reset(0)
end

--------------- ! Fonction qui permet de savoir sur quel type de case on est ! ---------------
function trouver_type_case()
	if (tab_map[case] == 1) then
		type_case = "chemin"
	elseif (tab_map[case] == 2) then
		type_case = "dpart"
	elseif (tab_map[case] == 3) then
		type_case = "arrive"
	elseif (tab_map[case] == 4) then
		type_case = "tlport"
	else
		type_case = "mur"
	end
end

--------------- ! Fonction qui permet de crer un evenement ! ---------------
function attribuer_evenement()
	-- ! Evenement 1 : Definir le dpart ! --
	if (num_event == 1) then
		-- On ajoute l'vnement.
		event[table.getn(event) + 1] = {num_carte = num_carte ; action = "depart" ; col = colonnes ; lig = lignes ; t_c = 0 ; t_l = 0 ; img = 1 ; couleur = "-255-000-000-"}
		-- On prcise que le choix d'ajouter le dpart n'est plus possible
		tab_choix_event[1].actif = false
		-- On change le type de la case
		tab_map[case] = 2
		-- On trie le tableau des evenements
		trier_tableau()
		
	-- ! Evenement 2 : Definir l'arrive ! --
	elseif (num_event == 2) then
		-- On ajoute l'entre.
		event[table.getn(event) + 1] = {num_carte = num_carte ; action = "arrivee" ; col = colonnes ; lig = lignes ; t_c = 0 ; t_l = 0 ; img = 2 ; couleur = "-000-120-230-"}
		-- On prcise que le choix d'ajouter l'arrive n'est plus possible
		tab_choix_event[2].actif = false
		-- On change le type de la case
		tab_map[case] = 3
		-- On trie le tableau des evenements
		trier_tableau()
		
	
	-- ! Evenement 3 : Crer un tlporteur
	elseif (num_event == 3) then
		-- On mmorise la case sur laquelle on tait
		tab_map[case] = "a"
		mem_case = case
		mem_col = colonnes
		mem_lig = lignes
		
		-- ! On demande  l'utilisateur de choisir l'arrive du tlport ! --
		ajout_teleport()
		
		-- ! On change le type des cases du tlport ! --
		tab_map[case] = 4
		tab_map[mem_case] = 4
		-- On ajoute l'vnement.
		event[table.getn(event) + 1] = {num_carte = num_carte ; action = "teleport" ; col = mem_col ; lig = mem_lig ; t_c = colonnes ; t_l = lignes ; img = 3 ; couleur = "-000-120-230-"}
		
		-- On demande si le tlport ne marche que dans un sens ou dans les deux --
		-- ! Message d'information ! --
		rafraichir = true
		message_teleport = false
		oldpad = Controls.read()
		masque = Image.createEmpty(480,272) -- on cre un masque
		masque:clear(Color.new(188,128,255,160))
		selecteur = true
		-- Tant que l'utilisateur n'a pas press X
		while (message_teleport == false) do
			pad = Controls.read()
			-- ! Si on doit actualiser l'cran
			if (rafraichir == true) then
				rafraichir = false
				screen:blit(0,0,background)
				actualiser_ecran()
				screen:blit(0,0,masque)
				Gu.start3d()
					IntraFont.load("flash0:/font/ltn4.pgf", 1)
					IntraFont.print((240 - ((IntraFont.print(240,130,"Peut-il tre pris dans les deux sens?",1,0,0) - 240)/2)),130,"Peut-il tre pris dans les deux sens?", 1,IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
					
					if (selecteur == true) then
						IntraFont.load("flash0:/font/ltn5.pgf", 1)
						IntraFont.print(40,170,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
						IntraFont.load("flash0:/font/ltn12.pgf", 1)
						IntraFont.print((440 - (IntraFont.print(0,200,"Non",1,0,0))),170,"Non",1,IntraFont.color(50,50,50,255),0)
					else
						IntraFont.load("flash0:/font/ltn12.pgf", 1)
						IntraFont.print(40,170,"Oui",1,IntraFont.color(50,50,50,255),0)
						IntraFont.load("flash0:/font/ltn5.pgf", 1)
						IntraFont.print((440 - (IntraFont.print(0,200,"Non",1,0,0))),170,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
					end
				Gu.end3d()
				screen.waitVblankStart()
				screen:flip()
			end
			if ((pad:right() and not oldpad:right()) or (pad:left() and not oldpad:left())) then
				if (selecteur == true) then
					selecteur = false
				else
					selecteur = true
				end
				rafraichir = true
			elseif (pad:cross() and not oldpad:cross()) then
					message_teleport = true
					delai(200)
			end
			oldpad = pad
		end
		if (selecteur == true) then
			-- S'il y a reciprocit, on ajoute l'evenement
			event[table.getn(event) + 1] = {num_carte = num_carte ; action = "teleport" ; col = colonnes ; lig = lignes ; t_c = mem_col ; t_l = mem_lig ; img = 3 ; couleur = "-000-120-230-"}
		end
	elseif (num_event == 4) then
		charger_cartes()
		charger_evenements()
		menu_principal()
	end
end

--------------- ! Fonction qui permet d'ajouter un tlport ! ---------------
function ajout_teleport()
	-- ! Message d'information ! --
	rafraichir = true
	message_teleport = false
	oldpad = Controls.read()
	masque = Image.createEmpty(480,272) -- on cre un masque
	masque:clear(Color.new(188,128,255,160))
	-- Tant que l'utilisateur n'a pas press X
	while (message_teleport == false) do
		pad = Controls.read()
		-- ! Si on doit actualiser l'cran
		if (rafraichir == true) then
			rafraichir = false
			screen:blit(0,0,background)
			actualiser_ecran()
			screen:blit(0,0,masque)
			Gu.start3d()
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,130,"Veuillez indiquer l'arrive du tleport.",1,0,0) - 240)/2)),130,"Veuillez indiquer l'arrive du tleport.", 1,IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn12.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,170,"Pressez X pour continuer",1,0,0) - 240)/2)),170,"Pressez X pour continuer", 1, IntraFont.color(0,0,0,255),0)
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:cross() and not oldpad:cross()) then
			message_teleport = true
			delai(200)
		end
		oldpad = pad
	end
	
	
	-- ! Choix de la case d'arrive du tleport ! --
	rafraichir = true
	fin_ajout_teleport = false
	oldpad = Controls.read()
	while (fin_ajout_teleport == false) do
		pad = Controls.read()
		
		-- ! Si l'cran doit tre actualis ! --
		if (rafraichir == true) then
			-- On affiche le fond ! --
			screen:blit(0,0,background)
			actualiser_ecran()
			screen.waitVblankStart()
			screen:flip()
		end
		
		-- ! Raction en fonction d'une touche ! --
		action_touche_teleport()
		
		oldpad = pad
	end
	delai(200)
	
end

--------------- ! Fonction qui permet d'enlever un evenement ! ---------------
function enlever_event()
	i = 1
	rang = 0
	-- On recherche o se trouve l'evenement  supprimer
	while (i <= table.getn(event)) and (rang == 0) do
		if (event[i].col == colonnes) and (event[i].lig == lignes) then
			rang = i
			type_event = event[i].action
		end
		i = i + 1
	end
	
	-- On deplace les elements  gauche
	for i = rang,table.getn(event) - 1 do
		event[i] = event[i + 1]
	end
	event[table.getn(event)] = nil
	
	if (type_event == "depart") then
		tab_choix_event[1].actif = true
	elseif (type_event == "arrivee") then
		tab_choix_event[2].actif = true
	else
		i = 1
		rang = 0
		-- On recherche o se trouve l'evenement  supprimer
		while (i <= table.getn(event)) and (rang == 0) do
			if (event[i].t_c == colonnes) and (event[i].t_l == lignes) then
				rang = i
				type_event = event[i].action
			end
			i = i + 1
		end
		if (rang ~= 0) then
			tab_map[(event[rang].lig-1)*nb_colonnes + event[rang].col] = 1
			-- On deplace les elements  gauche
			for i = rang,table.getn(event) - 1 do
				event[i] = event[i + 1]
			end
			event[table.getn(event)] = nil
		end
	end
end

--------------- ! Fonction qui permet de trier l'lment recherch  la place voulu! ---------------
function trier_tableau()
	-- ! Si le premier element n'est pas le depart ! --
	if (table.getn(event) > 1) then
		if (event[1].action ~= "depart") then
			ind_tri = 1
			id_depart = 0
			while (ind_tri <= table.getn(event)) and (id_depart == 0) do
				if (event[ind_tri].action == "depart") then
					id_depart = ind_tri
				end
				ind_tri = ind_tri + 1
			end
			if (id_depart ~= 0) then
				tab_temp = {}
				tab_temp = event[1]
				event[1] = event[id_depart]
				event[id_depart] = tab_temp
			end
			id_depart = nil
			tab_temp = nil
			
		end
		
		-- ! Si le second element n'est pas l'arrive ! --
		if (event[2].action ~= "arrivee") then
			ind_tri = 1
			id_arrivee = 0
			while (ind_tri <= table.getn(event)) and (id_arrivee == 0) do
				if (event[ind_tri].action == "arrivee") then
					id_arrivee = ind_tri
				end
				ind_tri = ind_tri + 1
			end
			if (id_arrivee ~= 0) then
				tab_temp = {}
				tab_temp = event[2]
				event[2] = event[id_arrivee]
				event[id_arrivee] = tab_temp
			end
			id_arrivee = nil
			tab_temp = nil
		end
	end
end

--------------- ! Fonction qui convertie la carte en une chaine de caractre ! ---------------
function convertir_carte(tableau_conversion)
	tab_carte = {}
	map_string = ""
	tab_c = tableau_conversion
	
	
	for j = 1,nb_lignes do
		for i = 1,nb_colonnes do
			case = (j - 1)*nb_colonnes + i
			if (tab_c[case] == 0) then
				tab_carte[case] = "0"
			else
				tab_carte[case] = "z"
				-- G,D,H,B
				tab_temp = {g = 0, d = 0, h = 0, b = 0}
				if ((tab_c[case - 1] ~= 0) and (i > 1)) then
					tab_temp.g = 1
				end
				if ((tab_c[case + 1] ~= 0) and (i < nb_colonnes))then
					tab_temp.d = 1
				end
				if ((tab_c[(case - nb_colonnes)] ~= 0) and (j > 1)) then
					tab_temp.h = 1
				end
				if ((tab_c[(case + nb_colonnes)] ~= 0) and (j < nb_lignes))then
					tab_temp.b = 1
				end
				
				if ((tab_temp.g == 1) and (tab_temp.d == 0) and (tab_temp.h == 0) and (tab_temp.b == 0)) then
					tab_carte[case] = "e"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 1) and (tab_temp.h == 0) and (tab_temp.b == 0)) then
					tab_carte[case] = "c"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 0) and (tab_temp.h == 1) and (tab_temp.b == 0)) then
					tab_carte[case] = "d"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 0) and (tab_temp.h == 0) and (tab_temp.b == 1)) then
					tab_carte[case] = "f"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 1) and (tab_temp.h == 0) and (tab_temp.b == 0)) then
					tab_carte[case] = "b"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 0) and (tab_temp.h == 1) and (tab_temp.b == 1)) then
					tab_carte[case] = "a"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 1) and (tab_temp.h == 0) and (tab_temp.b == 1)) then
					tab_carte[case] = "1"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 0) and (tab_temp.h == 0) and (tab_temp.b == 1)) then
					tab_carte[case] = "2"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 0) and (tab_temp.h == 1) and (tab_temp.b == 0)) then
					tab_carte[case] = "3"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 1) and (tab_temp.h == 1) and (tab_temp.b == 0)) then
					tab_carte[case] = "4"
				elseif ((tab_temp.g == 0) and (tab_temp.d == 1) and (tab_temp.h == 1) and (tab_temp.b == 1)) then
					tab_carte[case] = "5"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 0) and (tab_temp.h == 1) and (tab_temp.b == 1)) then
					tab_carte[case] = "6"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 1) and (tab_temp.h == 1) and (tab_temp.b == 0)) then
					tab_carte[case] = "7"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 1) and (tab_temp.h == 0) and (tab_temp.b == 1)) then
					tab_carte[case] = "8"
				elseif ((tab_temp.g == 1) and (tab_temp.d == 1) and (tab_temp.h == 1) and (tab_temp.b == 1)) then
					tab_carte[case] = "9"
				end
			end
			map_string = map_string..tab_carte[case]
		end
	end
end

--------------- ! Fonction qui sauvegarde la carte ! ---------------
function sauvegarder_carte()
	file = io.open("ms0:/PSP/GAME/cale/carte.txt","r")
	fin_lecture = false
	sauvegarde = {}
	while (fin_lecture == false) do
		data = file:read()
		if (data ~= "fin") then
			sauvegarde[table.getn(sauvegarde) + 1] = data
		else
			fin_lecture = true
		end
	end
	sauvegarde[table.getn(sauvegarde) + 1] = num_carte
	sauvegarde[table.getn(sauvegarde) + 1] = map_string
	sauvegarde[table.getn(sauvegarde) + 1] = nb_colonnes
	sauvegarde[table.getn(sauvegarde) + 1] = nb_lignes
	sauvegarde[table.getn(sauvegarde) + 1] = meilleur_temps
	sauvegarde[table.getn(sauvegarde) + 1] = record
	sauvegarde[table.getn(sauvegarde) + 1] = medaille
	file:close()
	
	file = io.open("ms0:/PSP/GAME/cale/carte.txt","w")
	for i = 1,table.getn(sauvegarde) do
		file:write(sauvegarde[i].."\n")
	end
	file:write("fin")
	file:close()
end

--------------- ! Fonction qui sauvegarde les evenements ! ---------------
function sauvegarder_events()
	file = io.open("ms0:/PSP/GAME/cale/evenements.txt","r")
		fin_lecture = false
		sauvegarde = nil
		sauvegarde = {}
		while (fin_lecture == false) do
			data = file:read()
			if (data ~= "fin") then
				sauvegarde[table.getn(sauvegarde) + 1] = data
			else
				fin_lecture = true
			end
		end
		for i = 1,table.getn(event) do
			sauvegarde[table.getn(sauvegarde) + 1] = num_carte
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].action
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].col
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].lig
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].t_c
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].t_l
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].img
			sauvegarde[table.getn(sauvegarde) + 1] = event[i].couleur
		end
	file:close()
	
	file = io.open("ms0:/PSP/GAME/cale/evenements.txt","w")
		for i = 1,table.getn(sauvegarde) do
			file:write(sauvegarde[i].."\n")
		end
		file:write("fin")
	file:close()
end

--------------- ! Fonction qui appellent les differentes fonctions pour la sauvegarde ! ---------------
function option_sauvegarde()
	if (map_en_edition == false) then
		if (table.getn(event) >= 2) then
			if (event[1].action == "depart") and (event[2].action == "arrivee") then
				demande_retracer_chemin(1)
				
				-- On recherche le chemin le plus court
				calcul_meilleur_temps()
				
				-- ! On transforme la carte en une chaine de caractres ! --
				convertir_carte(tab_map)
				
				-- ! On sauvegarde la carte ! --
				sauvegarder_carte()
				
				-- ! On sauvegarde l'venement ! --
				sauvegarder_events()
							
				num_map = num_carte
				mem_ligne = lignes
				mem_colonne = colonnes
				pre_edition()
				lignes = mem_ligne
				colonnes = mem_colonne
				fonction_principale()
			end
		end
	else
		if (table.getn(event) >= 2) then
			if (event[1].action == "depart") and (event[2].action == "arrivee") then
				
				-- On recherche le chemin le plus court
				demande_retracer_chemin(2)
				if (retracer_chemin == true) then
					calcul_meilleur_temps()
				end
				convertir_carte(tab_map)
				sauvegarde_modification()
			end
		end
	end
end

--------------- ! Fonction qui charge toutes les cartes ! ---------------
function charger_cartes()
	file = io.open("ms0:/PSP/GAME/cale/carte.txt","r")
	fin_lecture = false
	num_carte = 1
	ind_carte = 0
	cartes = {}
	cartes[1] = {num = 0 ; carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
	while (fin_lecture == false) do
		ind_carte = ind_carte + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (ind_carte == 1) then
				cartes[num_carte].num = tonumber(data)
			elseif (ind_carte == 2) then
				cartes[num_carte].carte = tostring(data)
			elseif (ind_carte == 3) then
				cartes[num_carte].c = tonumber(data)
			elseif (ind_carte == 4) then
				cartes[num_carte].l = tonumber(data)
			elseif (ind_carte == 5) then
				cartes[num_carte].tps = tonumber(data)
			elseif (ind_carte == 6) then
				cartes[num_carte].rec = tonumber(data)
			elseif (ind_carte == 7) then
				cartes[num_carte].med = tonumber(data)
				num_carte = num_carte + 1
				cartes[num_carte] = {num = 0 ; carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
				ind_carte = 0
			end
		end
	end
	num_carte = num_carte - 1
	cartes[table.getn(cartes)] = nil
	file:close()
end

--------------- ! Fonction qui charge tous les venements ! ---------------
function charger_evenements()
	file = io.open("ms0:/PSP/GAME/cale/evenements.txt","r")
	fin_lecture = false
	ind_evenement = 0
	num_evenement = 1
	evenements = {}
	evenements[1] = {num_carte = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c= 0; t_l = 0 ; img = 0 ; couleur = 1}
	while fin_lecture == false do
		ind_evenement = ind_evenement + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (ind_evenement == 1) then
				evenements[num_evenement].num_carte = tonumber(data)
			elseif (ind_evenement == 2) then
				evenements[num_evenement].action = tostring(data)
			elseif (ind_evenement == 3) then
				evenements[num_evenement].col = tonumber(data)
			elseif (ind_evenement == 4) then
				evenements[num_evenement].lig = tonumber(data)
			elseif (ind_evenement == 5) then
				evenements[num_evenement].t_c = tonumber(data)
			elseif (ind_evenement == 6) then
				evenements[num_evenement].t_l = tonumber(data)
			elseif (ind_evenement == 7) then
				evenements[num_evenement].img = tonumber(data)
			elseif (ind_evenement == 8) then
				evenements[num_evenement].couleur = tostring(data)
				num_evenement = num_evenement + 1
				evenements[num_evenement] = {num_carte = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c= 0; t_l = 0 ; img = 0 ; couleur = 1}
				ind_evenement = 0
			end
				
		end
	end
	num_evenement = num_evenement - 1
	evenements[table.getn(evenements)] = nil
	file:close()
end

--------------- ! Fonction qui crent les tables de sauvegarde lors d'une modification ! ---------------
function sauvegarde_modification()	
	i = 0
	carte_modifie = false
	while (i < table.getn(cartes)) and (carte_modifie == false) do
		i = i + 1
		if (cartes[i].num == num_carte) then
			cartes[i].carte = map_string
			cartes[i].tps = meilleur_temps
			carte_modifie = true
		end
	end
	temp = nil
	temp = {}
	for i = 1,table.getn(evenements) do
		if (evenements[i].num_carte ~= num_carte) then
			temp[table.getn(temp)+1] = evenements[i]
		end
	end
	evenements = temp
	for i = 1,table.getn(event) do
		evenements[table.getn(evenements)+1] = event[i]
	end
	trier_evemenents()
	creation_sauvegarde()
end

--------------- ! Fonction qui demande de retracer ou pas le chemin (lors d'une modification de carte) ! ---------------
function demande_retracer_chemin(var)
	confirmation = 0
	oldpad = Controls.read()
	rafraichir = true
	masque = Image.createEmpty(480,272) -- on cre un masque
	masque:clear(Color.new(188,128,255,160))
	selecteur = 1
	while confirmation == 0 do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			screen:blit(0,0,background)
			actualiser_ecran()
			screen:blit(0,0,masque)
			IntraFont.load("flash0:/font/ltn4.pgf", 1)
			Gu.start3d()
			if (var == 2) then
				IntraFont.print((240 - ((IntraFont.print(240,120,"Voici l'estimation du temps : "..(meilleur_temps/1000).."s",1,0,0) - 240)/2)),120,"Voici l'estimation du temps : "..(meilleur_temps/1000).."s", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,150,"Souhaitez-vous la recalculer?",1,0,0) - 240)/2)),150,"Souhaitez-vous la recalculer?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				if (selecteur == 1) then
					IntraFont.load("flash0:/font/ltn4.pgf", 1)
					IntraFont.print(200,190,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
					IntraFont.load("flash0:/font/ltn8.pgf", 1)
					IntraFont.print(250,190,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(50,50,50,255))
				else
					IntraFont.load("flash0:/font/ltn8.pgf", 1)
					IntraFont.print(200,190,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(50,50,50,255))
					IntraFont.load("flash0:/font/ltn4.pgf", 1)
					IntraFont.print(250,190,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				end
			else
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,120,"Veuillez tracer le chemin le plus court.",1,0,0) - 240)/2)),140,"Veuillez tracer le chemin le plus court.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				
			IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,120,"Croix pour continuer",1,0,0) - 240)/2)),250,"Croix pour continuer", 1, IntraFont.color(0,0,0,255),IntraFont.color(0,0,0,0))
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:right() and not oldpad:right()) then
			selecteur = 2
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			selecteur = 1
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			confirmation = selecteur
		end
		
		oldpad = pad
	end
	if (var == 2) then
		if (confirmation == 1) then
			retracer_chemin = true
		else
			retracer_chemin = false
		end
	end
end
---

