----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour le gameplay --

----------------------------------------------------------------------------------------------------------------------------------------

--------------- ! Fonction qui permet de deplacer Tinw ! ---------------
function deplacer_tinwe(touche)
	-- ! On vrifie qu'on peut se dplacer dans la direction choisie par le joueur ! --
	verifier_deplacement(touche)
	
	-- ! Si on peut bouger ! --
	if (autorisation_deplacement == true) then
		
		-- ! Si on se dplace vers la droite ! --
		if ((touche == "droite") and (x_tinwe + 32 <= 448) and (colonne < all_maps[id_map].c)) then
			-- Tant que Tinw ne s'est pas dplacer assez
			while (id_move_tinwe <= 16) do	
				-- On vrifie si on doit bouger Tinw ou bien la map 
				if (colonne < 8) or (colonne > all_maps[id_map].c - 8) then
					x_tinwe = x_tinwe + 2
				else
					x_map = x_map - 2
				end

				-- ! On actualise l'cran
				screen:clear(Color.new(170,215,255))
				actualiser_ecran(1)
				screen.waitVblankStart()
				screen:flip()
				
				-- On incremente le deplacement de Tinw
				id_move_tinwe = id_move_tinwe + 1
				if (chrono:time() < 100) or (tonumber(string.sub(chrono:time(),1,-3)) > mem_temps) then
					if (chrono:time() < 100) then
						mem_temps = 0
					else
						mem_temps = tonumber(string.sub(chrono:time(),1,-3))
					end
				end
			end
			
			-- ! On actualise les variables de positionnement ! --
			x_map = x_tinwe
			y_map = y_tinwe
			colonne = colonne + 1
			id_move_tinwe = 1
			
			
		-- ! Si on se dplace vers la gauche ! --	
		elseif ((touche == "gauche") and (x_tinwe - 32 >= 0) and (colonne > 1)) then
			-- Tant que Tinw ne s'est pas dplacer assez
			while (id_move_tinwe <= 16) do
				-- On vrifie si on doit bouger Tinw ou bien la map 
				if (colonne <= 8) or (colonne > all_maps[id_map].c - 7) then
					x_tinwe = x_tinwe - 2
				else
					x_map = x_map + 2
				end
				
				-- ! On actualise l'cran
				screen:clear(Color.new(170,215,255))
				actualiser_ecran(1)
				screen.waitVblankStart()
				screen:flip()
				
				-- On incremente le deplacement de Tinw
				id_move_tinwe = id_move_tinwe + 1
				if (chrono:time() < 100) or (tonumber(string.sub(chrono:time(),1,-3)) > mem_temps) then
					if (chrono:time() < 100) then
						mem_temps = 0
					else
						mem_temps = tonumber(string.sub(chrono:time(),1,-3))
					end
				end
			end
			
			-- ! On actualise les variables de positionnement ! --
			x_map = x_tinwe
			y_map = y_tinwe
			colonne = colonne - 1
			id_move_tinwe = 1
			
			
		-- ! Si on se dplace vers le bas ! --
		elseif ((touche == "bas") and (y_tinwe + 32 <= 272) and (ligne < all_maps[id_map].l)) then
			-- Tant que Tinw ne s'est pas dplacer assez
			while (id_move_tinwe <= 16) do
				-- On vrifie si on doit bouger Tinw ou bien la map 
				if (ligne < 4) or (ligne >= all_maps[id_map].l - 4) then
					y_tinwe = y_tinwe + 2
				else
					y_map = y_map - 2
				end
			
				-- ! On actualise l'cran
				screen:clear(Color.new(170,215,255))
				actualiser_ecran(1)
				screen.waitVblankStart()
				screen:flip()
				
				-- On incremente le deplacement de Tinw
				id_move_tinwe = id_move_tinwe + 1
				if (chrono:time() < 100) or (tonumber(string.sub(chrono:time(),1,-3)) > mem_temps) then
					if (chrono:time() < 100) then
						mem_temps = 0
					else
						mem_temps = tonumber(string.sub(chrono:time(),1,-3))
					end
				end
			end
			
			-- ! On actualise les variables de positionnement ! --
			x_map = x_tinwe
			y_map = y_tinwe
			ligne = ligne + 1
			id_move_tinwe = 1
		
		-- ! Si on se dplace vers le haut ! --
		elseif ((touche == "haut") and (y_tinwe - 32 >= 0) and (ligne > 1)) then
			-- Tant que Tinw ne s'est pas dplacer assez
			while (id_move_tinwe <= 16) do	
				-- On vrifie si on doit bouger Tinw ou bien la map 
				if (ligne <= 4) or (ligne > all_maps[id_map].l - 4) then
					y_tinwe = y_tinwe - 2
				else
					y_map = y_map + 2
				end
				
				-- ! On actualise l'cran
				screen:clear(Color.new(170,215,255))
				actualiser_ecran(1)
				screen.waitVblankStart()
				screen:flip()
				
				-- On incremente le deplacement de Tinw
				id_move_tinwe = id_move_tinwe + 1
				if (chrono:time() < 100) or (tonumber(string.sub(chrono:time(),1,-3)) > mem_temps) then
					if (chrono:time() < 100) then
						mem_temps = 0
					else
						mem_temps = tonumber(string.sub(chrono:time(),1,-3))
					end
				end
			end
			
			-- ! On actualise les variables de positionnement ! --
			x_map = x_tinwe
			y_map = y_tinwe
			ligne = ligne - 1
			id_move_tinwe = 1
		end
	end
end

--------------- ! Fonction qui permet de savoir si on peut se dplacer ! ---------------
function verifier_deplacement(sens)
	-- ! On dclare qu' la base du test, Tinw ne peut pas bouger ! --
	autorisation_deplacement = false
	
	-- ! Selon le sens de Tinw, on regarde si la case o on veut aller permet le dplacement
	if ((sens == "droite") and (colonne < all_maps[id_map].c)) then
		-- ! On mmorise la case o on veut aller
		case_suivante = tab_map[(all_maps[id_map].c*(ligne - 1)) + colonne + 1]
		-- ! On regarde si la case permet le deplacement ou non
		if ((case_suivante == 2) or (case_suivante == 3) or (case_suivante == 6) or (case_suivante == 7) or (case_suivante == 8) or (case_suivante == 9) or (case_suivante == 11) or (case_suivante == 14)) then
			autorisation_deplacement = true
		end
	
	elseif ((sens == "gauche") and (colonne > 1)) then
		case_suivante = tab_map[(all_maps[id_map].c*(ligne - 1)) + colonne - 1]
		if ((case_suivante == 1) or (case_suivante == 4) or (case_suivante == 5) or (case_suivante == 7) or (case_suivante == 8) or (case_suivante == 9) or (case_suivante == 11) or (case_suivante == 12)) then
			autorisation_deplacement = true
		end
	
	elseif ((sens == "bas") and (ligne < all_maps[id_map].l)) then
		case_suivante = tab_map[(all_maps[id_map].c*(ligne)) + colonne]
		if ((case_suivante == 3) or (case_suivante == 4) or (case_suivante == 5) or (case_suivante == 6) or (case_suivante == 7) or (case_suivante == 9) or (case_suivante == 10) or (case_suivante == 13)) then
			autorisation_deplacement = true
		end
	
	elseif ((sens == "haut") and (ligne > 1)) then
		case_suivante = tab_map[(all_maps[id_map].c*(ligne - 2)) + colonne]
		if ((case_suivante == 1) or (case_suivante == 2) or (case_suivante == 5) or (case_suivante == 6) or (case_suivante == 8) or (case_suivante == 9) or (case_suivante == 10) or (case_suivante == 15)) then
			autorisation_deplacement = true
		end
	end
end

--------------- ! Fonction qui permet de savoir s'il y a une action sur la case o on est ! ---------------
function verifier_action_possible()
	i = 0 -- Indice
	-- ! On dclare qu' la base du test, il n'y a aucune action ! --
	verif_action = false
	
	-- ! Tant qu'on a pas vrifi tous les evenements ! --
	while ((i < nb_events)) do
		i = i + 1
		-- ! S'il y a un evenement ! --
		if ((events[i].lig == ligne) and (events[i].col == colonne)) then
			verif_action = true
			id_action = i
		end
	end
	
	-- ! S'il y a une action, on la dclenche ! --
	if (verif_action == true) then
		declencher_action()
	end
end

--------------- ! Fonction qui permet de raliser un evenement ! ---------------
function declencher_action()
	-- ! Si l'evenement est une tlportation ! --
	if (events[id_action].action == "teleport") then
		-- ! Si la case o se trouve Tinw n'tait pas ajout au tableau des cases visites ! --
		if (tab_passage[(all_maps[id_map].c*(ligne - 1) + colonne)] == false) then
			tab_passage[(all_maps[id_map].c*(ligne - 1) + colonne)] = true
		end
		
		-- ! On cre un masque qui fera un fondu ! --
		masque = Image.createEmpty(480,272)
		opaque = 0
		masque:clear(Color.new(0,0,0,opaque))
		
		-- ! On passe de l'cran au noir ! --
		while (opaque <= 255) do
			screen:clear(Color.new(170,215,255))
			actualiser_ecran()
			screen:blit(0,0,masque)
			screen.waitVblankStart()
			screen:flip()
			opaque = opaque + 15
			masque:clear(Color.new(0,0,0,opaque))
		end
		
		-- ! On repositionne Tinw  sa nouvelle case ! --
		ligne = events[id_action].t_l
		colonne = events[id_action].t_c
		positionner_tinwe()
		-- ! On passe du noir  l'cran ! --
		while (opaque >= 0) do
			screen:clear(Color.new(170,215,255))
			actualiser_ecran()
			screen:blit(0,0,masque)
			screen.waitVblankStart()
			screen:flip()
			opaque = opaque - 15
			masque:clear(Color.new(0,0,0,opaque))
		end
		
		masque,opaque = nil
	-- ! Si l'evenement est un passage au niveau suivant ! --
	elseif (events[id_action].action == "arrivee") then
		changement_niveau()
		
	end
	delai(150)
end

--------------- ! Fonction des touches dans le menu principal ! ---------------
function action_touche_menu_principal()
	if (pad:up() and not oldpad:up()) then
		if (selecteur == 1) then
			selecteur = 4
		elseif (selecteur == 3) and (table.getn(all_maps) == 0) then
			selecteur = 1
		else
			selecteur = selecteur - 1
		end
		rafraichir = true
	elseif (pad:down() and not oldpad:down()) then
		if (selecteur == 1) and (table.getn(all_maps) == 0) then
			selecteur = 3
		elseif (selecteur == 4) then
			selecteur = 1
		else
			selecteur = selecteur + 1
		end
		rafraichir = true
	elseif (pad:cross() and not oldpad:cross()) then
		choix = selecteur
	end

end
-----