----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour le graphique --

----------------------------------------------------------------------------------------------------------------------------------------

--------------- ! Fonction qui permet d'actualiser l'cran du jeu! ---------------
function actualiser_ecran(param_aff)
	rafraichir = false
	
	-- Afficher la map
	afficher_map("statique")
	
	-- On affiche Tinw
	screen:blit(x_tinwe,y_tinwe,img_tinwe)
	screen:blit(x_tinwe - 48, y_tinwe - 48, halo_tinwe)
	screen:fillRect(0,0,480,y_tinwe - 48,Color.new(0,0,0))
	screen:fillRect(0,y_tinwe - 48,x_tinwe - 48,128,Color.new(0,0,0))
	screen:fillRect(x_tinwe + 80,y_tinwe - 48,480,128,Color.new(0,0,0))
	screen:fillRect(0,y_tinwe + 80,480,272,Color.new(0,0,0))
	screen:blit(0,-2,cadre_map)
	screen:blit(0,240,cadre_map)
	if (param_aff == 1) then
		Gu.start3d()
		if (mem_temps > 590) then
			IntraFont.print(20,20,"Temps : "..math.floor((mem_temps/600)).."'"..math.floor(math.mod(mem_temps,600)/10).."''"..math.mod(math.mod(mem_temps,600),10),1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
		else
			
			IntraFont.print(20,20,"Temps : "..math.floor(mem_temps/10).."''"..math.mod(mem_temps,10),1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
		end
		IntraFont.print(390,20,"Niveau : "..id_map,1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
		IntraFont.print(10,260,"Or : "..medaille_convert.gold,1,IntraFont.color(255,215,0,255),IntraFont.color(0,0,0,255))
		IntraFont.print((240 - ((IntraFont.print(240,200,"Argent : "..medaille_convert.silver,1,0,0) - 240)/2)),260,"Argent : "..medaille_convert.silver,1,IntraFont.color(206,206,206,255),IntraFont.color(0,0,0,255))
		IntraFont.print((470 - (IntraFont.print(0,200,"Bronze : "..medaille_convert.bronze,1,0,0))),260,"Bronze : "..medaille_convert.bronze,1,IntraFont.color(97,78,26,255),IntraFont.color(0,0,0,255))
		Gu.end3d()
	end
end
	
--------------- ! Fonction qui permet d'afficher la map ! ---------------
function afficher_map()
	k = - 3
	-- ! On affiche que 5 lignes (deux au dessus de Tinw et 2 en dessous)
	for i = 1,5 do
		l = - 2
		-- ! On affiche que 5 colonnes (deux avant Tinw et 2 aprs)
		for j = 1,5 do
			-- ! On stocke le numero de l'image  affiche en fonction de la case o on se trouve
			case = tab_map[(all_maps[id_map].c*(ligne + k)) + colonne + l]
			-- ! S'il y a quelque chose, on affiche le sprite de la case ! --
			if (case ~= 0) and (case ~= nil) then
				screen:blit(x_map + (32*l),y_map + (k*32)+32,sprite_map,cut_map[case].x,cut_map[case].y,32,32)
			end
			-- ! On regarde s'il y a un evenement  afficher sur cette case ! --
			for e = 1,nb_events do
				if ((ligne + k + 1 == events[e].lig) and (colonne + l == events[e].col)) then
					screen:blit(x_map + (32*l),y_map + (k*32) + 32,img_events[events[e].img])
				end
			end
			-- ! On passe  la colonne suivante ! --
			l = l + 1
		end
		-- ! On passe  la ligne suivante ! --
		k = k + 1
	end
end

--------------- ! Fonction qui permet d'afficher la carte des zones explores ! ---------------
function afficher_carte()
	-- ! On construit la map en fonction de ce qui a t explor ! --
	concevoir_carte()
	oldpad = pad
	fin_afficher_carte = false
	
	-- ! Tant que le joueur n'a pas appuyer sur start() ! --
	while fin_afficher_carte == false do
		pad = Controls.read()
		
		-- ! Touche start : revenir  l'exploration
		if (pad:triangle() and not oldpad:triangle()) then
			fin_afficher_carte = true
			rafraichir = true
		end
		
		-- ! On efface l'cran ! -- 
		screen:clear(Color.new(0,0,0))
		
		-- ! On affiche un cadre pour delimite la taille de la map
		screen:fillRect(x_carte-2,y_carte-2,(all_maps[id_map].c - 2)*unite_carte + 4,(all_maps[id_map].l - 2)*unite_carte + 4,Color.new(255,255,255))
		screen:fillRect(x_carte,y_carte,(all_maps[id_map].c - 2)*unite_carte,(all_maps[id_map].l - 2)*unite_carte,Color.new(38,38,92))
		
		-- ! On fait toutes les lignes de la map ! --
		for j = 1,all_maps[id_map].l - 2 do	
			-- ! On fait toutes les colonnes ! --
			for i = 1, all_maps[id_map].c - 2 do
				
				-- ! On place l'indice de la case en cours ! --
				case = 	((j-1)*(all_maps[id_map].c - 2))+i
				
				-- Si Tinw est dj pass par cette case, on l'affiche
				if (tab_carte[case] ~= 0) then
					
					-- ! Si Tinw se trouve sur cette case ! --
					if (case == id_cale) then
						screen:fillRect(x_carte + (i - 1)*unite_carte,y_carte + (j - 1)*unite_carte,unite_carte,unite_carte,Color.new(255,185,90))
					else
						screen:fillRect(x_carte + (i - 1)*unite_carte,y_carte + (j - 1)*unite_carte,unite_carte,unite_carte,tab_couleur[case])
					end
					
					
					-- ! On affiche le trac de la case ! --
					if ((tab_carte[case] == 7) or (tab_carte[case] == 8) or (tab_carte[case] == 9) or (tab_carte[case] == 11)) then
						screen:fillRect(x_carte + (i - 1)*unite_carte,y_carte + (j - 1)*unite_carte+mi_case,unite_carte,2,Color.new(255,255,255))
					end
					if ((tab_carte[case] == 5) or (tab_carte[case] == 6) or (tab_carte[case] == 9) or (tab_carte[case] == 10)) then
						screen:fillRect(x_carte + (i - 1)*unite_carte+mi_case,y_carte + (j - 1)*unite_carte,2,unite_carte,Color.new(255,255,255))
					end
					if ((tab_carte[case] == 1) or (tab_carte[case] == 2) or (tab_carte[case] == 8) or (tab_carte[case] == 15)) then
						screen:fillRect(x_carte + (i - 1)*unite_carte +mi_case,y_carte + (j - 1)*unite_carte +mi_case ,2,mi_case + 2,Color.new(255,255,255))
						
					end
					if ((tab_carte[case] == 3) or (tab_carte[case] == 4) or (tab_carte[case] == 7) or (tab_carte[case] == 13)) then
						screen:fillRect(x_carte + (i - 1)*unite_carte + mi_case,y_carte + (j - 1)*unite_carte,2,mi_case + 2,Color.new(255,255,255))
						
					end
					if ((tab_carte[case] == 1) or (tab_carte[case] == 4) or (tab_carte[case] == 5) or (tab_carte[case] == 12)) then
						screen:fillRect(x_carte + (i - 1)*unite_carte + mi_case,y_carte + (j - 1)*unite_carte + mi_case,mi_case + 2,2,Color.new(255,255,255))
						
					end
					if ((tab_carte[case] == 2) or (tab_carte[case] == 3) or (tab_carte[case] == 6) or (tab_carte[case] == 14)) then
						screen:fillRect(x_carte + (i - 1)*unite_carte,y_carte + (j - 1)*unite_carte + mi_case,mi_case + 2,2,Color.new(255,255,255))
						
					end
				end
			end
		end
		
		screen:flip()
		oldpad = pad
	end

end

--------------- ! Fonction qui permet d'afficher le menu principal ! ---------------
function afficher_menu()
	IntraFont.init()
	rafraichir = false
	screen:blit(0,0,background)
	Gu.start3d()
		IntraFont.load("flash0:/font/ltn12.pgf", 1)
		if (selecteur == 1) then
			IntraFont.print((240 - ((IntraFont.print(240,200,"Arcade",1,0,0) - 240)/2)),200,"Arcade", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,220,"Partie personnalise",1,0,0) - 240)/2)),220,"Partie personnalise", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Options",1,0,0) - 240)/2)),240,"Options", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Cl [Editor]",1,0,0) - 240)/2)),260,"Cl [Editor]", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
		elseif (selecteur == 2) then
			IntraFont.print((240 - ((IntraFont.print(240,200,"Arcade",1,0,0) - 240)/2)),200,"Arcade", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,220,"Partie personnalise",1,0,0) - 240)/2)),220,"Partie personnalise", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Options",1,0,0) - 240)/2)),240,"Options", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Cl [Editor]",1,0,0) - 240)/2)),260,"Cl [Editor]", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
		elseif (selecteur == 3) then
			IntraFont.print((240 - ((IntraFont.print(240,200,"Arcade",1,0,0) - 240)/2)),200,"Arcade", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,220,"Partie personnalise",1,0,0) - 240)/2)),220,"Partie personnalise", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Options",1,0,0) - 240)/2)),240,"Options", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Cl [Editor]",1,0,0) - 240)/2)),260,"Cl [Editor]", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
		elseif (selecteur == 4) then
			IntraFont.print((240 - ((IntraFont.print(240,200,"Arcade",1,0,0) - 240)/2)),200,"Arcade", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,220,"Partie personnalise",1,0,0) - 240)/2)),220,"Partie personnalise", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Options",1,0,0) - 240)/2)),240,"Options", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			IntraFont.print((240 - ((IntraFont.print(240,240,"Cl [Editor]",1,0,0) - 240)/2)),260,"Cl [Editor]", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
		end
	Gu.end3d()
	IntraFont.term()
end

--------------- ! Fonction qui permet d'afficher le menu des options ! ---------------
function afficher_menu_option(var)
	IntraFont.init()
	rafraichir = false
	screen:blit(0,0,background)
	Gu.start3d()
		IntraFont.load("flash0:/font/ltn12.pgf", 1)
		if (var == 1) then
			if (selecteur == 1) then
				IntraFont.print((240 - ((IntraFont.print(240,200,"Rinitialiser Arcade",1,0,0) - 240)/2)),200,"Rinitialiser Arcade", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,220,"Rinitialiser Partie personnalise",1,0,0) - 240)/2)),220,"Rinitialiser Partie personnalise", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,240,"Crdits",1,0,0) - 240)/2)),240,"Crdits", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			elseif (selecteur == 2) then
				IntraFont.print((240 - ((IntraFont.print(240,200,"Rinitialiser Arcade",1,0,0) - 240)/2)),200,"Rinitialiser Arcade", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,220,"Rinitialiser Partie personnalise",1,0,0) - 240)/2)),220,"Rinitialiser Partie personnalise", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,240,"Crdits",1,0,0) - 240)/2)),240,"Crdits", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
			elseif (selecteur == 3) then
				IntraFont.print((240 - ((IntraFont.print(240,200,"Rinitialiser Arcade",1,0,0) - 240)/2)),200,"Rinitialiser Arcade", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,220,"Rinitialiser Partie personnalise",1,0,0) - 240)/2)),220,"Rinitialiser Partie personnalise", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,240,"Crdits",1,0,0) - 240)/2)),240,"Crdits", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			end
		end
	Gu.end3d()
	IntraFont.term()
end

--------------- ! Fonction qui permet d'afficher les niveaux lors du choix de niveau ! ---------------
function afficher_niveau()
	screen:blit(0,0,img_choix_niveau)
	pos_sel_x = 60
	pos_sel_y = 15
	j = 0
	IntraFont.load("flash0:/font/ltn4.pgf", 1)
	for i = 1, table.getn(tab_sel) do
		j = j + 1
		if (tab_sel[i].num > niveau_bloque) and (type_partie == 1) then
			screen:blit(pos_sel_x, pos_sel_y,tab_medaille[6])
		else
			screen:blit(pos_sel_x, pos_sel_y,tab_medaille[tab_sel[i].medaille])
		end
		Gu.start3d()
		IntraFont.print(pos_sel_x + ((60 - IntraFont.print(0,0,tab_sel[i].num,1,1,1))/2),pos_sel_y + 35,tab_sel[i].num,1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))	
		Gu.end3d()
		if (i == ind_niveau) then
			screen:blit(pos_sel_x,pos_sel_y,img_sel_niv)
		end
		if (j == 5) then
			j = 0
			pos_sel_x = 60
			pos_sel_y = pos_sel_y + 75
		else
			pos_sel_x = pos_sel_x + 75
		end
	end
	Gu.start3d()
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
	for k = 1,nb_page do
		if (k == page) then
			IntraFont.print((init_x + (k-1)*15),255,k,1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
		else
			IntraFont.print((init_x + (k-1)*15),255,k,1,IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
		end
	end
	Gu.end3d()
end
---