--------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour tout ce qui touchent aux fichiers txt --

----------------------------------------------------------------------------------------------------------------------------------------

--------------- ! Fonction qui charge toutes les maps contenues dans un txt ! ---------------
function creer_maps(var)
	if (var == 1) then
		file = io.open("scripts_lua/cartes_principales.txt","r")
		niveau_bloque = 0
	else
		niveau_bloque = 0
		file = io.open("carte.txt","r")
	end
	fin_lecture = false
	num_carte = 1
	ind_carte = 0
	all_maps = {}
	all_maps[1] = {num = 0 ; carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
	
	while (fin_lecture == false) do
		ind_carte = ind_carte + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (var == 1) then
				if (ind_carte == 1) then
					all_maps[num_carte].c = tonumber(data)
				elseif (ind_carte == 2) then
					all_maps[num_carte].rec = tonumber(data)
					if (niveau_bloque == 0) and (all_maps[num_carte].rec == 0) then
						niveau_bloque = num_carte
					end
				elseif (ind_carte == 3) then
					all_maps[num_carte].num = tonumber(data)
				elseif (ind_carte == 4) then
					all_maps[num_carte].med = tonumber(data)
				elseif (ind_carte == 5) then
					all_maps[num_carte].l = tonumber(data)
				elseif (ind_carte == 6) then
					all_maps[num_carte].tps = tonumber(data)
				elseif (ind_carte == 7) then
					all_maps[num_carte].carte = tostring(data)
					num_carte = num_carte + 1
					all_maps[num_carte] = {carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
					ind_carte = 0
				end
			else
				if (ind_carte == 1) then
					all_maps[num_carte].num = tonumber(data)
				elseif (ind_carte == 2) then
					all_maps[num_carte].carte = tostring(data)
				elseif (ind_carte == 3) then
					all_maps[num_carte].c = tonumber(data)
				elseif (ind_carte == 4) then
					all_maps[num_carte].l = tonumber(data)
				elseif (ind_carte == 5) then
					all_maps[num_carte].tps = tonumber(data)
				elseif (ind_carte == 6) then
					all_maps[num_carte].rec = tonumber(data)
				elseif (ind_carte == 7) then
					all_maps[num_carte].med = tonumber(data)
					num_carte = num_carte + 1
					all_maps[num_carte] = {carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
					ind_carte = 0
				end
			end
		end
	end
	file:close()
	num_carte = num_carte - 1
	all_maps[table.getn(all_maps)] = nil
	if (niveau_bloque == 0) then
		niveau_bloque = table.getn(all_maps) + 1
	end
end

--------------- ! Fonction qui charge toutes les evenements contenus dans un txt ! ---------------
function creer_events(var)
	if (var == 1) then
		file = io.open("scripts_lua/evenements_principaux.txt","r") 
	else
		file = io.open("evenements.txt","r") 
	end
	fin_lecture = false
	num_event = 1
	ind_event = 0
	all_events = {}
	all_events[1] = {id = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c = 0 ; t_l = 0 ; img = 0 ; couleur = 0}
	while fin_lecture == false do
		ind_event = ind_event + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (var == 1) then
				if (ind_event == 1) then
					all_events[num_event].t_l = tonumber(data)
				elseif (ind_event == 2) then
					all_events[num_event].col = tonumber(data)
				elseif (ind_event == 3) then
					all_events[num_event].img = tonumber(data)
				elseif (ind_event == 4) then
					all_events[num_event].lig = tonumber(data)
				elseif (ind_event == 5) then
					all_events[num_event].t_c = tonumber(data)
				elseif (ind_event == 6) then
					all_events[num_event].action = tostring(data)
				elseif (ind_event == 7) then
					all_events[num_event].couleur = Color.new(tonumber(string.sub(data,2,4)),tonumber(string.sub(data,6,8)),tonumber(string.sub(data,10,12)))
				elseif (ind_event == 8) then
					all_events[num_event].id = tonumber(data)
					num_event = num_event + 1
					all_events[num_event] = {id = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c = 0 ; t_l = 0 ; img = 0 ; couleur = 0}
					ind_event = 0
				end
			else
				if (ind_event == 1) then
					all_events[num_event].id = tonumber(data)
				elseif (ind_event == 2) then
					all_events[num_event].action = tostring(data)
				elseif (ind_event == 3) then
					all_events[num_event].col = tonumber(data)
				elseif (ind_event == 4) then
					all_events[num_event].lig = tonumber(data)
				elseif (ind_event == 5) then
					all_events[num_event].t_c = tonumber(data)
				elseif (ind_event == 6) then
					all_events[num_event].t_l = tonumber(data)
				elseif (ind_event == 7) then
					all_events[num_event].img = tonumber(data)
				elseif (ind_event == 8) then
					all_events[num_event].couleur = Color.new(tonumber(string.sub(data,2,4)),tonumber(string.sub(data,6,8)),tonumber(string.sub(data,10,12)))
					num_event = num_event + 1
					all_events[num_event] = {id = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c = 0 ; t_l = 0 ; img = 0 ; couleur = 0}
					ind_event = 0
				end
			end
		end
	end
	num_event = num_event - 1
	all_events[table.getn(all_events)] = nil
	file:close()
end

--------------- ! Fonction qui sauvegarde les maps & evenements modifis dans un txt ! ---------------
function sauvegarder_partie(var)
	sauvegarde = nil
	sauvegarde = {}
	-- ! On liste les cartes ! --
	if (var == 1) then
		for i = 1,table.getn(all_maps) do
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].c
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].rec
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].num
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].med
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].l
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].tps
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].carte
		end
	else
		for i = 1,table.getn(all_maps) do
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].num
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].carte
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].c
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].l
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].tps
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].rec
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].med
		end
	end
	-- ! On sauvegarde dans un fichier texte ! --
	
	if (var == 1) then
		file = io.open("scripts_lua/cartes_principales.txt","w")
	else
		file = io.open("carte.txt","w")
	end
	for i = 1,table.getn(sauvegarde) do
		file:write(sauvegarde[i].."\n")
	end
	-- ! On crit la balise de fin ! --
	file:write("fin".."\n")
	file:write("fin")
	file:close()
end

--------------- ! Fonction qui demande confirmation pour la rinitialisation ! ---------------
function reinitialiser_arcade(var)
	background = Image.load("images/autres/background.png")
	choix_reinit = 0
	oldpad = Controls.read()
	selecteur = 1
	rafraichir = true
	while (choix_reinit == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_menu_option(2)
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn8.pgf", 1)
			
			if (var == 1) then
				IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir rinitialiser le mode Arcade?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir rinitialiser le mode Arcade?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			else
				IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir rinitialiser le mode Partie Personnalise?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir rinitialiser le mode Partie Personnalise?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			end
			IntraFont.load("flash0:/font/ltn13.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,240,"(Mdailles et records seront effacs)",1,0,0) - 240)/2)),220,"(Mdailles et records seront effacs)", 1, IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
			else
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
			end
			
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:right() and not oldpad:right()) then
			selecteur = 2
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			selecteur = 1
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			choix_reinit = selecteur
		elseif (pad:circle() and not oldpad:circle()) then
			choix_reinit = 2
		end
		oldpad = pad
	end
	if (choix_reinit == 1) then
		background, choix_reinit, oldpad, selecteur, rafraichir = nil
		remise_a_zero(var)
		menu_option()
	elseif (choix_reinit == 2) then
		background, choix_reinit, oldpad, selecteur, rafraichir = nil
		menu_option()
	end
end

--------------- ! Fonction qui rinitialise les records et medailles des maps ! ---------------
function remise_a_zero(var)
	creer_maps(var)
	creer_events(var)
	if (table.getn(all_maps) > 0) then
		for i = 1,table.getn(all_maps) do
			all_maps[i].rec = 0
			all_maps[i].med = 1
		end
		sauvegarder_partie(var)
	end
end