----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour calculer le temps le plus rapide pour effectuer le labyrinthe --

----------------------------------------------------------------------------------------------------------------------------------------



--------------- ! Fonction principale ! ---------------
function calcul_meilleur_temps()	
	-- || ETAPE 1 : Creation des variables || --
	meilleur_temps = 0 -- Temps final  la fin du trac du circuit
	fin_calcul = false -- Permet de sortir de la boucle principale
	rafraichir = true -- Permet l'actualisation de l'cran
	col_temps = event[1].col -- Permet de se positionner sur la case de dpart
	lig_temps = event[1].lig
	
	tab_trace = {}
	tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 0}
	tab_touche = {} -- Mmorise qu'elle touche on a press
	tab_touche[table.getn(tab_touche)+1] = {sens = "" ; teleport = false}
	oldpad = Controls.read()
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
	
	-- || ETAPE 2 : Boucle principale - l'utilisateur trace le chemin le plus court || --
	while (fin_calcul == false) do
		pad = Controls.read()
		-- ! Si l'cran doit tre actualis ! --
		if (rafraichir == true) then
			screen:blit(0,0,background)
			screen:blit(0,-2,cadre_info)
			afficher_carte(2)
			afficher_ecran_calcul()
			meilleur_temps = 0
			for i = 1,table.getn(tab_trace) do
				meilleur_temps = meilleur_temps + tab_trace[i].tps
			end
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn12.pgf", 1)
			IntraFont.print(10,17,"Temps estim du parcours : "..(meilleur_temps/1000).."s",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		
		-- ! Si une touche est presse ! --
		action_calcul()
		
		if (type_case_actuel == 3) then
			fin_trajet()
		end
		oldpad = pad
	end
end

--------------- ! Fonction qui permet ou pas, le deplacement pour le trac ! ---------------
function action_calcul()
	-- || ETAPE 1 : On cherche sur quel type de case en on est || --
	type_case_actuel = tab_map[(lig_temps-1)*nb_colonnes + (col_temps)]
	
	-- || ETAPE 2 : On modifie ou non le trace du chemin le plus court || --
	-- ! Touche Droite ! --
	if (pad:right() and not oldpad:right()) then
		-- ! On regarde le type de la case suivante ! --
		type_case_suivant = tab_map[(lig_temps-1)*nb_colonnes + (col_temps+1)]
		
		-- ! Si on reprend un tleport ! --
		--if (type_case_suivant == 4) and (tab_touche[table.getn(tab_touche)].teleport == true) and (tab_touche[table.getn(tab_touche)].sens ~= "droite") then
		if (type_case_suivant == 4) and (tab_touche[table.getn(tab_touche)].teleport == true) and (tab_trace[table.getn(tab_trace)-1].c == col_temps+1) then
			
			tab_touche[table.getn(tab_touche)] = nil		
			tab_trace[table.getn(tab_trace)] = nil	
			tab_trace[table.getn(tab_trace)] = nil
			col_temps = tab_trace[table.getn(tab_trace)].c
			lig_temps = tab_trace[table.getn(tab_trace)].l
			rafraichir = true
		else
			-- ! On regarde si on ne rebrousse pas chemin ! --
			if ((tab_touche[table.getn(tab_touche)].sens == "gauche") and (prise_teleport == false))then
				col_temps = col_temps + 1
				tab_touche[table.getn(tab_touche)] = nil
				tab_trace[table.getn(tab_trace)] = nil
				rafraichir = true
			else	
				-- ! On regarde si on peut se deplacer sur la case de droite ! --
				if (type_case_suivant ~= 0) then
					col_temps = col_temps + 1
					tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 266}
					if (prise_teleport == true) then
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "droite" ; teleport = true}
					else
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "droite" ; teleport = false}
					end
					-- ! On regarde si on n'est pas sur un tleport ! --
					if (type_case_suivant == 4) then
						tab_trace[table.getn(tab_trace)] = {c = col_temps ; l = lig_temps ; tps = 1675}
						tab_touche[table.getn(tab_touche)] = {sens = "droite" ; teleport = true}
						-- ! On parcourt les evenements jusqu' trouver le tleport ! --
						i = 0
						fin_recherche = false
						while (i < table.getn(event)) and (fin_recherche == false) do
							i = i + 1
							if (event[i].col == col_temps) and (event[i].lig == lig_temps) then
								col_temps = event[i].t_c
								lig_temps = event[i].t_l
								tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 0}
								fin_recherche = true
								prise_teleport = true
							end
						end
					end
				end
				rafraichir = true
			end
		end
		
	-- ! Touche Gauche ! --
	elseif (pad:left() and not oldpad:left()) then
		-- ! On regarde le type de la case suivante ! --
		type_case_suivant = tab_map[(lig_temps-1)*nb_colonnes + (col_temps-1)]
		
		-- ! Si on reprend un tleport ! --
		if (type_case_suivant == 4) and (tab_touche[table.getn(tab_touche)].teleport == true) and (tab_trace[table.getn(tab_trace)-1].c == col_temps-1) then
			tab_touche[table.getn(tab_touche)] = nil		
			tab_trace[table.getn(tab_trace)] = nil	
			tab_trace[table.getn(tab_trace)] = nil
			col_temps = tab_trace[table.getn(tab_trace)].c
			lig_temps = tab_trace[table.getn(tab_trace)].l
			rafraichir = true
		else
			-- ! On regarde si on ne rebrousse pas chemin ! --
			if ((tab_touche[table.getn(tab_touche)].sens == "droite")  and (prise_teleport == false))then
				col_temps = col_temps - 1
				tab_touche[table.getn(tab_touche)] = nil
				tab_trace[table.getn(tab_trace)] = nil
				rafraichir = true
			else	
				-- ! On regarde si on peut se deplacer sur la case de droite ! --
				if (type_case_suivant ~= 0) then
					col_temps = col_temps - 1
					tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 266}
					if (prise_teleport == true) then
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "gauche" ; teleport = true}
					else
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "gauche" ; teleport = false}
					end
					-- ! On regarde si on n'est pas sur un tleport ! --
					if (type_case_suivant == 4) then
						tab_trace[table.getn(tab_trace)] = {c = col_temps ; l = lig_temps ; tps = 1675}
						tab_touche[table.getn(tab_touche)] = {sens = "gauche" ; teleport = true}
						-- ! On parcourt les evenements jusqu' trouver le tleport ! --
						i = 0
						fin_recherche = false
						while (i < table.getn(event)) and (fin_recherche == false) do
							i = i + 1
							if (event[i].col == col_temps) and (event[i].lig == lig_temps) then
								col_temps = event[i].t_c
								lig_temps = event[i].t_l
								tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 0}
								fin_recherche = true
								prise_teleport = true
							end
						end
					end
				end
				rafraichir = true
			end
		end
	-- ! Touche Haut ! --
	elseif (pad:up() and not oldpad:up()) then
		-- ! On regarde le type de la case suivante ! --
		type_case_suivant = tab_map[(lig_temps-2)*nb_colonnes + (col_temps)]
		
		-- ! Si on reprend un tleport ! --
		if (type_case_suivant == 4) and (tab_touche[table.getn(tab_touche)].teleport == true) and (tab_trace[table.getn(tab_trace)-1].l == lig_temps-1) then
			tab_touche[table.getn(tab_touche)] = nil		
			tab_trace[table.getn(tab_trace)] = nil	
			tab_trace[table.getn(tab_trace)] = nil
			col_temps = tab_trace[table.getn(tab_trace)].c
			lig_temps = tab_trace[table.getn(tab_trace)].l
			rafraichir = true
		else
			-- ! On regarde si on ne rebrousse pas chemin ! --
			if ((tab_touche[table.getn(tab_touche)].sens == "bas") and (prise_teleport == false)) then
				lig_temps = lig_temps - 1
				tab_touche[table.getn(tab_touche)] = nil
				tab_trace[table.getn(tab_trace)] = nil
				rafraichir = true
			else	
				-- ! On regarde si on peut se deplacer sur la case de droite ! --
				if (type_case_suivant ~= 0) then
					lig_temps = lig_temps - 1
					tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 266}
					if (prise_teleport == true) then
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "haut" ; teleport = true}
					else
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "haut" ; teleport = false}
					end
					-- ! On regarde si on n'est pas sur un tleport ! --
					if (type_case_suivant == 4) then
						tab_trace[table.getn(tab_trace)] = {c = col_temps ; l = lig_temps ; tps = 1675}
						tab_touche[table.getn(tab_touche)] = {sens = "haut" ; teleport = true}
						-- ! On parcourt les evenements jusqu' trouver le tleport ! --
						i = 0
						fin_recherche = false
						while (i < table.getn(event)) and (fin_recherche == false) do
							i = i + 1
							if (event[i].col == col_temps) and (event[i].lig == lig_temps) then
								col_temps = event[i].t_c
								lig_temps = event[i].t_l
								tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 0}
								fin_recherche = true
								prise_teleport = true
							end
						end
					end
				end
				rafraichir = true
			end
		end
		
	-- ! Touche Bas ! --
	elseif (pad:down() and not oldpad:down()) then
		-- ! On regarde le type de la case suivante ! --
		type_case_suivant = tab_map[(lig_temps)*nb_colonnes + (col_temps)]
		
		-- ! Si on reprend un tleport ! --
		if (type_case_suivant == 4) and (tab_touche[table.getn(tab_touche)].teleport == true) and (tab_trace[table.getn(tab_trace)-1].l == lig_temps+1) then
			tab_touche[table.getn(tab_touche)] = nil		
			tab_trace[table.getn(tab_trace)] = nil	
			tab_trace[table.getn(tab_trace)] = nil
			col_temps = tab_trace[table.getn(tab_trace)].c
			lig_temps = tab_trace[table.getn(tab_trace)].l
			rafraichir = true
		else
			-- ! On regarde si on ne rebrousse pas chemin ! --
			if ((tab_touche[table.getn(tab_touche)].sens == "haut") and (prise_teleport == false)) then
				lig_temps = lig_temps + 1
				tab_touche[table.getn(tab_touche)] = nil
				tab_trace[table.getn(tab_trace)] = nil
				rafraichir = true
			else	
				-- ! On regarde si on peut se deplacer sur la case de droite ! --
				if (type_case_suivant ~= 0) then
					lig_temps = lig_temps + 1
					tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 266}
					if (prise_teleport == true) then
						prise_teleport = false
						tab_touche[table.getn(tab_touche)+1] = {sens = "bas" ; teleport = true}
					else
						tab_touche[table.getn(tab_touche)+1] = {sens = "bas" ; teleport = false}
						prise_teleport = false
					end
					-- ! On regarde si on n'est pas sur un tleport ! --
					if (type_case_suivant == 4) then
						tab_trace[table.getn(tab_trace)] = {c = col_temps ; l = lig_temps ; tps = 1675}
						tab_touche[table.getn(tab_touche)] = {sens = "bas" ; teleport = true}
						-- ! On parcourt les evenements jusqu' trouver le tleport ! --
						i = 0
						fin_recherche = false
						while (i < table.getn(event)) and (fin_recherche == false) do
							i = i + 1
							if (event[i].col == col_temps) and (event[i].lig == lig_temps) then
								col_temps = event[i].t_c
								lig_temps = event[i].t_l
								tab_trace[table.getn(tab_trace)+1] = {c = col_temps ; l = lig_temps ; tps = 0}
								fin_recherche = true
								prise_teleport = true
							end
						end
					end
				end
				rafraichir = true
			end
		end
		
	end
end

--------------- ! Fonction qui affiche le trac du chemin ! ---------------
function afficher_ecran_calcul()
	pos_t = 30
	for i = 1,table.getn(tab_trace) do
		pos_x = ((480 - (nb_colonnes*unite))/2) + ((tab_trace[i].c - 1)*unite)
		pos_y = (32 + (240 - (nb_lignes*unite))/2) + ((tab_trace[i].l - 1)*unite)
		if (i == table.getn(tab_trace)) then
			screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,0,0))
		else
			screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,50,50))
		end
		pos_t = pos_t+10
		-- screen:print(10,60,"A gauche : "..tab_map[(lig_temps-1)*nb_colonnes + (col_temps-1)],Color.new(255,255,255))
		-- screen:print(10,70,"A droite : "..tab_map[(lig_temps-1)*nb_colonnes + (col_temps+1)],Color.new(255,255,255))
		-- screen:print(200,60,"En haut : "..tab_map[(lig_temps-2)*nb_colonnes + (col_temps)],Color.new(255,255,255))
		-- screen:print(200,70,"En bas : "..tab_map[(lig_temps)*nb_colonnes + (col_temps)],Color.new(255,255,255))
		-- screen:print(10,80,"Case position : "..tab_map[(lig_temps-1)*nb_colonnes + (col_temps)],Color.new(255,0,0))
		
		-- screen:print(10,200,"Touche : "..tab_touche[table.getn(tab_touche)].sens.." "..tostring(tab_touche[table.getn(tab_touche)].teleport),Color.new(255,255,255))
		-- screen:print(10,220,"Prise teleport : "..tostring(prise_teleport),Color.new(255,255,255))
	end
end

--------------- ! Fonction qui demande la confirmation pour la fin du trajet ! ---------------
function fin_trajet()
	confirmation = 0
	oldpad = Controls.read()
	rafraichir = true
	meilleur_temps = 0
	masque = Image.createEmpty(480,272) -- on cre un masque
	masque:clear(Color.new(188,128,255,160))
	selecteur = 1
	for i = 1,table.getn(tab_trace) do
		meilleur_temps = meilleur_temps + tab_trace[i].tps
	end
	while confirmation == 0 do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			ecran_fin_trajet()
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:right() and not oldpad:right()) then
			selecteur = 2
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			selecteur = 1
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			confirmation = selecteur
		end
		
		oldpad = pad
	end
	if (confirmation == 1) then
		fin_calcul = true
	else
		tab_trace[table.getn(tab_trace)] = nil
		tab_touche[table.getn(tab_touche)] = nil
		col_temps = tab_trace[table.getn(tab_trace)].c
		lig_temps = tab_trace[table.getn(tab_trace)].l
		rafraichir = true
	end
end

--------------- ! Fonction qui organise l'cran lors de la confirmation pour la fin du trajet ! ---------------
function ecran_fin_trajet()
	screen:blit(0,0,background)
	screen:blit(0,-2,cadre_info)
	afficher_carte(2)
	afficher_ecran_calcul()
	
	screen:blit(0,0,masque)
	IntraFont.load("flash0:/font/ltn4.pgf", 1)
	Gu.start3d()
	IntraFont.print((240 - ((IntraFont.print(240,120,"Voici l'estimation du temps : "..(meilleur_temps/1000).."s",1,0,0) - 240)/2)),120,"Voici l'estimation du temps : "..(meilleur_temps/1000).."s", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
	IntraFont.load("flash0:/font/ltn8.pgf", 1)
	IntraFont.print((240 - ((IntraFont.print(240,150,"Valider ce chemin? (non pour le reprendre)",1,0,0) - 240)/2)),150,"Valider ce chemin? (non pour le reprendre)", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
	if (selecteur == 1) then
		IntraFont.load("flash0:/font/ltn4.pgf", 1)
		IntraFont.print(200,190,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
		IntraFont.load("flash0:/font/ltn8.pgf", 1)
		IntraFont.print(250,190,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(50,50,50,255))
	else
		IntraFont.load("flash0:/font/ltn8.pgf", 1)
		IntraFont.print(200,190,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(50,50,50,255))
		IntraFont.load("flash0:/font/ltn4.pgf", 1)
		IntraFont.print(250,190,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
	end
	Gu.end3d()
end
-----