----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour le gameplay (essentiellement les touches) --

----------------------------------------------------------------------------------------------------------------------------------------



--------------- ! Lors du choix du nombre de colonnes et de lignes ! ---------------
function action_touche_initialisation()
	-- Touche Gauche : Nombre decrement de 1
	if (pad:left() and valider_num_carte == true) then
		if (num_clavier > min_num) then
			num_clavier = num_clavier - 1
			rafraichir = true
			delai(150)
		end
		
	-- Touche Droite : Nombre increment de 1
	elseif (pad:right() and valider_num_carte == true) then
		num_clavier = num_clavier + 1
		if (max_num <= num_clavier) then
			num_clavier = max_num
		end
		delai(150)
		rafraichir = true
	
	-- Touche Haut : Nombre increment de 10
	elseif (pad:up() and valider_num_carte == true) then
		num_clavier = num_clavier + 10
		if (max_num <= num_clavier) then
			num_clavier = max_num
		end
		delai(150)
		rafraichir = true
	
	-- Touche Bas : Nombre decrement de 10
	elseif (pad:down() and valider_num_carte == true) then
		if (num_clavier > min_num + 9) then
			num_clavier = num_clavier - 10
			delai(150)
			rafraichir = true
		end
		
	-- Touche Croix : Validation de la valeur 
	elseif (pad:cross() and not oldpad:cross()) then
		if (valider_num_carte == false) then
			num_carte = num_clavier
			valider_num_carte = true
			num_clavier = 10
			min_num = 5
			max_num = 25
			rafraichir = true
		elseif (nb_colonnes == 0) then
			nb_colonnes = num_clavier + 2
			num_clavier = 6
			max_num = 25
			min_num = 5
			rafraichir = true
		elseif (nb_lignes == 0) then
			nb_lignes = num_clavier + 2
			rafraichir = true
		end
		delai(200)
	elseif (pad:circle() and not oldpad:circle()) then
		if (nb_colonnes == 0) or (valider_num_carte == false) then
			menu_principal()
		elseif (nb_lignes == 0) then
			nb_colonnes = 0
			num_clavier = 10
			min_num = 5
			max_num = 25
			rafraichir = true
		end
	end
end

--------------- ! Lors de la cration de la map ! ---------------
function action_touche()
	-- Touche Droite : Passage  la case de droite ! --
	if(pad:right()) then
		if (colonnes < nb_colonnes - 1) then
			colonnes = colonnes + 1
		else
			colonnes = 2
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
	
	-- Touche Gauche : Passage  la case de gauche ! --
	elseif (pad:left()) then
		if (colonnes > 2) then
			colonnes = colonnes - 1
		else
			colonnes = nb_colonnes - 1
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
		
	-- Touche Bas : Passage  la case en dessous ! --
	elseif(pad:down()) then
		if (lignes < nb_lignes - 1) then
			lignes = lignes + 1
		else
			lignes = 2
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
		
	-- Touche Haut : Passage  la case du dessus ! --
	elseif (pad:up()) then
		if (lignes > 2) then
			lignes = lignes - 1
		else
			lignes = nb_lignes - 1
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
	
	-- Touche Triangle : Ajouter un evenement sur la case du selecteur ! --
	elseif (pad:triangle() and not oldpad:triangle() and (type_case == "chemin")) then
		ajouter_event()
		
	-- Touche Carr : Enlever l'evenement de la case du selecteur ! --
	elseif (pad:square() and not oldpad:square() and (type_case ~= "chemin") and (type_case ~= "mur")) then
		enlever_event()
		rafraichir = true
		tab_map[case] = 1
	end
	
	-- Touche Croix : Dfinir la case comme tant pratiquable (Tinw peut marcher dessus) ! --
	if (pad:cross()) then
		if (tab_map[case] == 0)then
			tab_map[case] = 1
			rafraichir = true
		end
	
	-- Touche Rond : Dfinir la case comme tant non pratiquable ! --
	elseif (pad:circle()) then
		if (((type_case == "chemin") or (type_case == "mur"))) then
			if (tab_map[case] == 1) then
				tab_map[case] = 0
				rafraichir = true
			end
		end
	end
	
	
	--if (pad:start() and (event[1].action == "depart") and (event[2].action == "arrivee")) then
	if (pad:start() and not oldpad:start()) then
		menu_pause()
	end
end

--------------- ! Lors du choix de l'venement  ajouter ! ---------------
function action_choix_evenement()
	-- ! Touche Haut : Selectionner l'venement prcedent ! --
	if (pad:up() and not oldpad:up()) then
		-- Si on est au premier choix, ou sur le deuxieme mais que le premier est impossible, ou bien sur le troisieme mais que les deux premiers sont impossibles
		if ((ind_event == 1) or ((ind_event == 2) and (tab_choix_event[1].actif == false)) or ((ind_event == 3) and (tab_choix_event[1].actif == false) and (tab_choix_event[2].actif == false)))then
			ind_event = table.getn(tab_choix_event)
		elseif ((ind_event == 3) and (tab_choix_event[2].actif == false)) then
			ind_event = 1
		else
			ind_event = ind_event - 1
		end
		rafraichir = true
	
	-- ! Touche Bas : Selectionner l'venement suivant ! --
	elseif (pad:down() and not oldpad:down()) then
		if (ind_event == 5) then
			if (tab_choix_event[1].actif == false) then
				if (tab_choix_event[2].actif == false) then
					ind_event = 3
				else
					ind_event = 2
				end
			else
				ind_event = 1
			end
		elseif (ind_event == 1) and (tab_choix_event[2].actif == false) then
			ind_event = 3
		else
			ind_event = ind_event + 1
		end
		rafraichir = true
		
	-- ! Touche Croix : Selectionner l'venement ! --
	elseif (pad:cross() and not oldpad:cross()) then
		num_event = ind_event
	end
	
	if (pad:l()) then
			screen:save("ms0:/screen/editor/image"..math.random(1,5000)..".png")
		end
end

--------------- ! Lors de l'ajout d'un tleport, pour definir la case d'arrive  ! ---------------
function action_touche_teleport()
	-- Touche Droite : Passage  la case de droite ! --
	if(pad:right()) then
		if (colonnes < nb_colonnes - 1) then
			colonnes = colonnes + 1
		else
			colonnes = 2
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
	
	-- Touche Gauche : Passage  la case de gauche ! --
	elseif (pad:left()) then
		if (colonnes > 2) then
			colonnes = colonnes - 1
		else
			colonnes = nb_colonnes - 1
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
		
	-- Touche Bas : Passage  la case en dessous ! --
	elseif(pad:down()) then
		if (lignes < nb_lignes - 1) then
			lignes = lignes + 1
		else
			lignes = 2
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
		
	-- Touche Haut : Passage  la case du dessus ! --
	elseif (pad:up()) then
		if (lignes > 2) then
			lignes = lignes - 1
		else
			lignes = nb_lignes - 1
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
		
	-- Touche Croix : Valider 
	elseif (pad:cross() and (tab_map[case] == 1)) then
		case_arrivee = (lignes-1)*nb_colonnes + colonnes
		fin_ajout_teleport = true
	end
end

--------------- ! Lors de l'ajout d'un tlport, pour choisir la couleur de celui-ci sur l'aperu de la carte ! ---------------
function action_touche_palette()
	-- Touche Droite : Passage  la case de droite ! --
	if(pad:right()) then
		if (selecteur_x < 5) then
			selecteur_x = selecteur_x + 1
		else
			selecteur_x = 1
		end
		rafraichir = true
		delai(150)
	
	-- Touche Gauche : Passage  la case de gauche ! --
	elseif (pad:left()) then
		if (selecteur_x > 1) then
			selecteur_x = selecteur_x - 1
		else
			selecteur_x = 5
		end
		rafraichir = true
		delai(150)
		
	-- Touche Bas : Passage  la case en dessous ! --
	elseif(pad:down()) then
		if (selecteur_y < 5) then
			selecteur_y = selecteur_y + 1
		else
			selecteur_y = 1
		end
		case = (lignes-1)*nb_colonnes + colonnes
		rafraichir = true
		delai(150)
		
	-- Touche Haut : Passage  la case du dessus ! --
	elseif (pad:up()) then
		if (selecteur_y > 1) then
			selecteur_y = selecteur_y - 1
		else
			selecteur_y = 5
		end
		rafraichir = true
		delai(150)
		
	-- Touche Croix : Valider 
	elseif (pad:cross()) then
		couleur_teleport = tab_couleur[(5*(selecteur_y-1))+selecteur_x]
		fin_couleur_teleport = true
	end
end

--------------- ! Fonction qui permet d'ajouter un evenement ! ---------------
function ajouter_event()
	-- ! Indice initiale pour l'venement ! --
	if (tab_choix_event[1].actif == false) then
		if (tab_choix_event[2].actif == false) then
			ind_event = 3
		else
			ind_event = 2
		end
	else
		ind_event = 1
	end
	-- ! L'evenement qu'aura choisi l'utilisateur ! --
	num_event = 0
	rafraichir = true
	oldpad = Controls.read()
	
	-- ! Tant que l'utilisateur n'a pas choisi le type d'evenement
	while (num_event == 0) do
		pad = Controls.read()
		
		-- ! Si l'cran doit tre actualis ! --
		if (rafraichir == true) then
			afficher_choix_evenement()
		end
		
		-- ! Raction en fonction d'une touche ! --
		action_choix_evenement()
		
		oldpad = pad
	end
	
	-- ! On applique le choix de l'utilisateur ! -- 
	if (num_event ~= table.getn(tab_choix_event)) then
		attribuer_evenement()
	end
	rafraichir = true
end

--------------- ! Lors de la gestion d'une carte sauvegard ! ---------------
function action_gestion()
	-- Touche Droite 
	if (pad:right() and not oldpad:right()) then
		if (navigation == true) then
			-- ! Changement de carte ; passage  la suivante ! --
			if (num_map == table.getn(cartes)) then
				num_map = 1
			else
				num_map = num_map + 1
			end
			nouveau_num = num_map
			generer_apercu(num_map)
		elseif ((navigation == false) and (selecteur == 2)) then
			-- ! Changement de numro de carte ! --
			if (nouveau_num == table.getn(cartes)) then
				nouveau_num = 1
			else
				nouveau_num = nouveau_num + 1
			end
		end
		rafraichir = true
	
	-- Touche Gauche
	elseif (pad:left() and not oldpad:left()) then
		if (navigation == true) then
			-- ! Changement de carte ; retour  la precedente ! --
			if (num_map == 1) then
				num_map = table.getn(cartes)
			else
				num_map = num_map - 1
			end
			nouveau_num = num_map
			generer_apercu(num_map)
		elseif ((navigation == false) and (selecteur == 2)) then
			-- ! Changement de numro de carte ! --
			if (nouveau_num == 1) then
				nouveau_num = table.getn(cartes)
			else
				nouveau_num = nouveau_num - 1
			end
		end
		rafraichir = true
	
	-- Touche Haut : On revient au choix de gestion prcedent
	elseif (pad:up() and not oldpad:up()) then
		if (navigation == false) then
			if (selecteur == 1) then
				selecteur = 3
			else
				selecteur = selecteur - 1
			end
			rafraichir = true
		end

	-- Touche Bas : On passe au choix de gestion suivant
	elseif (pad:down() and not oldpad:down()) then
		if (navigation == false) then
			if (selecteur == 3) then
				selecteur = 1
			else
				selecteur = selecteur + 1
			end
			rafraichir = true
		end
	
	-- Touche Croix : On valide la modification  effectuer sur la carte
	elseif (pad:cross() and not oldpad:cross()) then
		if (navigation == false) then
			-- ! Choix 1 : Edition de la carte ! --
			if (selecteur == 1) then
				pre_edition()
				fonction_principale()
			-- ! Choix 2 : Changement de la place de la carte parmi les autres ! --
			elseif(selecteur == 2) then
				redefinir_rang()
				navigation = true
				num_map = nouveau_num
				generer_apercu(num_map)
				rafraichir = true
				creation_sauvegarde()
			-- ! Choix 3 : Suppression de la carte ! --
			else
				supprimer_carte()
			end
		end
	
	-- Touche Rond 
	elseif (pad:circle() and not oldpad:circle()) then
		if (navigation == false) then
			-- Retour au choix de la carte sur laquelle effectuer une modification
			navigation = true
			rafraichir = true
		else
			-- Retour au menu principale
			menu_principal()
		end
	
	-- Touche Triangle : Affichage ou masquage des options de modification
	elseif (pad:triangle() and not oldpad:triangle()) then
		if (navigation == true) then
			navigation = false
		else
			navigation = true
		end
		rafraichir = true
	end
end

---